unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, TeeComma, ExtCtrls, TeeProcs, TeEngine, Chart,
  StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Chart1Resize(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure MakeScaledAxes;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Series, TeCanvas, Math;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  Chart1.View3D:=False;
  Chart1.Legend.Visible:=False;
  Chart1.AddSeries(TLineSeries.Create(Self));

  for i:=0 to 10 do
    Chart1[0].AddXY(i/10, i/20);

end;

procedure TForm1.MakeScaledAxes;
var
  OriginalRect: TRect;
  ScaledRect  : TRect;
  AxisRatio   : Double;
  BottomRange : Double;
  LeftRange   :Double;
  tmpWidth    : Integer;
  tmpHeight   : Integer;
begin   
  Chart1.CustomChartRect:=False;
  Chart1.Draw;
  OriginalRect:=Chart1.ChartRect;

  BottomRange:=Chart1.Axes.Bottom.Maximum - Chart1.Axes.Bottom.Minimum;
  LeftRange:=Chart1.Axes.Left.Maximum - Chart1.Axes.Left.Minimum;
  AxisRatio:=BottomRange/LeftRange;

  tmpWidth:=OriginalRect.Right - OriginalRect.Left;
  tmpHeight:=OriginalRect.Bottom - OriginalRect.Top;

  if AxisRatio > 1 then
    tmpHeight:=Round(tmpWidth * 1/AxisRatio)
  else
    tmpWidth:=Round(tmpHeight * AxisRatio);

  ScaledRect:=TeeRect(0, 0, tmpWidth - Chart1.Axes.Left.MaxLabelsWidth,
                      tmpHeight + Chart1.Title.Height);

  Chart1.CustomChartRect:=True;
  Chart1.ChartRect:=ScaledRect;
end;

procedure TForm1.Chart1Resize(Sender: TObject);
begin
  MakeScaledAxes;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MakeScaledAxes;
  Chart1.OnResize:=Chart1Resize;
  Chart1.Align:=alClient;
end;

end.

